
package Prints::Model::Sql::SqlMotif;

use strict;
use Exporter;

use vars qw(@ISA);
use base qw(Prints::Model::Motif Prints::Model::Sql::SqlRoot Exporter);

use Pg;


sub _lookup{
  my $self = shift;

  if( ! defined( $self->{lookup} ) ){
    my $fp_acc = $self->fingerprint->accession;
    my $sq_acc = $self->sequence->accession;
    my $number = $self->motif_number;
    my $result = $self->_exec( "select * from motif where fprint_accn= '$fp_acc' "
                               . " and seqn_accn= '$sq_acc' and motif= '$number';" );

    $self->_getfield( $result, "repeat" );
    $self->_getfield( $result, "seqn_fragment" );
    $self->_getfield( $result, "start_position" );
    $self->_getfield( $result, "inter_motif_dist" );
    $self->_getfield( $result, "initial" );
    $self->_getfield( $result, "final" );
    $self->{lookup} = 1;
  }
}

sub repeat{
  my $self = shift;
  $self->_lookup;

  return $self->{repeat};
}

sub sequence_fragment{
  my $self = shift;
  $self->_lookup;

  return $self->{seqn_fragment};
}

sub start_position{
  my $self = shift;
  $self->_lookup;

  return $self->{start_position};
}

sub inter_motif_distance{
  my $self = shift;
  $self->_lookup;

  return $self->{inter_motif_dist};
}

sub initial{
  my $self = shift;
  $self->_lookup;

  return $self->{initial};
}

sub final{
  my $self = shift;
  $self->_lookup;

  return $self->{final};
}

1;
